Subject: Re: bug#12494: 0 exit status even when chmod fails

From: Sven Joachim <[email-masked]>
Date: Mon, 24 Sep 2012 21:21:18 +0200

On 2012-09-24 08:37 +0200, Alan Curry wrote:

> Georgiy Treyvus writes:
>> 
>> Finally I had him show me the mount options of the relevant partitions. 
>> Many I recognized. Some I did not. I started researching those I did 
>
> Did you notice this one?:
>
> Mount options for fat
>        (Note:  fat  is	not  a	separate  filesystem, but a common part of the
>        msdos, umsdos and vfat filesystems.)
>
> [...]
>        quiet  Turn on the quiet flag.  Attempts to chown or chmod files do not
> 	      return errors, although they fail. Use with caution!
>
> If you're getting the quiet behavior without the quiet mount option, I'd say
> that's a kernel bug.

Actually, it's the default unless you're using Linux 2.6.25.  This
kernel reported an error to the caller, but since that broke rsync[1,2],
2.6.26 reverted to the previous behavior of silently ignoring chmod
attempts which do not work on FAT filesystems[3].

This bug report should probably be closed.

Cheers,
       Sven

1. https://bugzilla.redhat.com/show_bug.cgi?id=449080
2. http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=495594
3. http://git.kernel.org/?p=linux/kernel/git/torvalds/linux.git;a=commitdiff;h=2d518f84e5ecd1d71df0e6ac5176d212f68c27ce